package com.fs.starfarer.api.impl.campaign.rulecmd;

import kaysaar.aotd_question_of_loyalty.data.scripts.commision.AoTDCommissionUtil;
import java.awt.Color;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.util.Misc;
import java.util.List;
import kaysaar.aotd_question_of_loyalty.data.models.RankData;
import com.fs.starfarer.api.characters.PersonAPI;
import java.util.Map;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.campaign.rules.MemoryAPI;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.OptionPanelAPI;
import com.fs.starfarer.api.campaign.TextPanelAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.CampaignFleetAPI;

public class AoTDHandlePromotion extends BaseCommandPlugin
{
    protected CampaignFleetAPI playerFleet;
    protected SectorEntityToken entity;
    protected FactionAPI playerFaction;
    protected FactionAPI entityFaction;
    protected TextPanelAPI text;
    protected OptionPanelAPI options;
    protected CargoAPI playerCargo;
    protected MemoryAPI memory;
    protected InteractionDialogAPI dialog;
    protected Map<String, MemoryAPI> memoryMap;
    protected PersonAPI person;
    protected FactionAPI faction;
    protected RankData daten;
    protected RankData currDaten;
    
    public boolean execute(final String ruleId, final InteractionDialogAPI dialog, final List<Misc.Token> params, final Map<String, MemoryAPI> memoryMap) {
        this.dialog = dialog;
        this.memoryMap = memoryMap;
        this.memory = getEntityMemory((Map)memoryMap);
        final String command = params.get(0).getString((Map)memoryMap);
        if (command == null) {
            return false;
        }
        this.entity = dialog.getInteractionTarget();
        this.text = dialog.getTextPanel();
        this.options = dialog.getOptionPanel();
        this.playerFleet = Global.getSector().getPlayerFleet();
        this.playerCargo = this.playerFleet.getCargo();
        String id = null;
        if (Global.getSector().getMemory().contains("$aotd_rank_temp")) {
            id = Global.getSector().getMemory().getString("$aotd_rank_temp");
        }
        final String currid = AoTDCommIntelPlugin.get().getRank();
        this.daten = AoTDCommIntelPlugin.get().getRankForID(id);
        this.currDaten = AoTDCommIntelPlugin.get().getRankForID(currid);
        this.playerFaction = Global.getSector().getPlayerFaction();
        this.entityFaction = this.entity.getFaction();
        this.person = dialog.getInteractionTarget().getActivePerson();
        this.faction = this.person.getFaction();
        if (command.equals("initConversation")) {
            dialog.getOptionPanel().clearOptions();
            if (this.currDaten.isLeavingAnOption()) {
                dialog.getTextPanel().addPara("不过丑话说在前面，当你晋升到这个位置之后，想脱离这段关系的难度比你一步步爬上来不遑多让——很多时候你没得选。若有朝一日你选择背叛，我们将视你为最高优先级威胁。", Color.ORANGE);
                dialog.getOptionPanel().addOption("Yes, I am aware of this", (Object)"aotd_confirm_no_going_back");
                dialog.getOptionPanel().addOption("我得再想想，恐怕我现在还没准备好", (Object)"aotd_return_no_rank");
            }
            else if (this.daten != null) {
                dialog.getTextPanel().addPara("You have proven yourself useful, and your efforts have greatly helped our faction");
                dialog.getTextPanel().addPara("Given your request and power bestowed by our leaders");
                dialog.getTextPanel().addPara("From now on your rank shall be %s", Color.ORANGE, new String[] { this.daten.name });
                dialog.getOptionPanel().addOption("I shall serve.", (Object)"aotd_return");
            }
        }
        if (command.equals("overrideInitConversation")) {
            dialog.getOptionPanel().clearOptions();
            dialog.getTextPanel().addPara("You have proven yourself useful, and your efforts have greatly helped our faction");
            dialog.getTextPanel().addPara("Given your request and power bestowed by our leaders");
            dialog.getTextPanel().addPara("From now on your rank shall be %s", Color.ORANGE, new String[] { this.daten.name });
            dialog.getOptionPanel().addOption("I shall serve.", (Object)"aotd_return");
        }
        if (command.equals("promote")) {
            AoTDCommIntelPlugin.get().setRank(id);
            AoTDCommissionUtil.reportPlayerGotNewRank(AoTDCommIntelPlugin.get().getCurrentRankData());
        }
        return true;
    }
}
